local AceConfig = LibStub("AceConfig-3.0")
OSSD_Spell = 0;
OSSD_Throttle = 0.1;
OSSD_UpdCol = 0;
if (OSSD_TEXT_FontSize == nil) then OSSD_TEXT_FontSize = 10 end
if (OSSD_ShowText == nil) then OSSD_ShowText = true end
if (OSSD_Width == nil) then OSSD_Width = 55 end
if (OSSD_Height == nil) then OSSD_Height = 17 end
if (OSSD_Select == nil) then OSSD_Select = "sdamage" end
OSSD_SetValues = {		["sdamage"] = "Spell Damage", 
						["shealing"] = "Spell Healing", 
						["attackpower"] = "Attack Power", 
						["rattackpower"] = "Ranged Attack Power",
						["armor"] = "Armor",
						["block"] = "Block",
						["dodge"] = "Dodge",
						["mcrit"] = "Melee Crit",
						["rcrit"] = "Ranged Crit",
						["scrit"] = "Spell Crit",
						["mhit"] = "Melee Hit",
						["rhit"] = "Ranged Hit",
						["shit"] = "Spell Hit",
						["mhaste"] = "Melee Haste",
						["rhaste"] = "Ranged Haste",
						["shaste"] = "Spell Haste",
						
						["mana"] = "Mana",
						["health"] = "Health",
						["energy"] = "Energy",
						["rage"] = "Rage",
						["runic"] = "Runic Power",
						["apen"] = "Armor Penetration"}

local ossdmod = LibStub("AceAddon-3.0"):NewAddon("OSSD", "AceConsole-3.0")
ossdmod.config = {
	type = 'group',
	order = 15,
	name = "OSSD",
	desc = "OSSD CONF",
	handler = module,
	args = {
		General = {
			type = 'group',
			order = 1,
			name = "Settings",
			desc = "Settings",
			args = {
				
						showType = {
						order = 0,
						type = "multiselect",
						name = "Select Setting",
						desc = "",
						values = OSSD_SetValues,
						set = function(info, n) OSSD_ChangeValue(n) end,
						get = function(info, n) return OSSD_IsVal(n)  end,
						--width = "full",
						},
				display2 = {
					type = 'group',
					order = 11,
					name = "Box Settings",
					desc = "Select a stat to display",
					guiInline = true,
					args = {
				barwidth = {
					type = "range",
					name = "Width",
					desc = "Set the width of the stats bar",
					func = timeFunc,
					order = 30,
					get = function() return OSSD_FRAME:GetWidth() end,
					set = function(info, n) 
						OSSD_FRAME:SetWidth(n)
						OSSD_TEXT:SetWidth(n) 
						OSSD_Width = n
					end,
					min = 50,
					max = 150,
					step = 1,
				},
				barheight= {
					type = "range",
					name = "Height",
					desc = "Set the height of the stats bar",
					func = timeFunc,
					order = 31,
					get = function() return OSSD_FRAME:GetHeight() end,
					set = function(info, n) 
						OSSD_FRAME:SetHeight(n)
						OSSD_TEXT:SetHeight(n)
						OSSD_Height = n						
					end,
					min = 17,
					max = 150,
					step = 1,
				},
				},
				},
				
				display3 = {
					type = 'group',
					order = 20,
					name = "Font Size",
					desc = "",
					guiInline = true,
					args = {
					fontsize= {
					type = "range",
					name = "Font Size",
					desc = "",
					func = timeFunc,
					order = 31,
					get = function() 
					local fontName, fontHeight, fontFlags = OSSD_TEXT:GetFont()
						return math.floor(fontHeight+0.5);
					end,
					set = function(info, n) 
						local fontName, fontHeight, fontFlags = OSSD_TEXT:GetFont()
						OSSD_TEXT:SetFont(fontName, n, "")	
						OSSD_TEXT_FontSize = n
					end,
					min = 2,
					max = 26,
					step = 1,
					},
					},
				},
				adv = {
					type = 'group',
					order = 90,
					name = "Advanced",
					desc = "",
					guiInline = true,
					args = {
					showText = {
						order = 0,
						type="toggle",
						name = "Show Stats Text",
						desc = "Toggles the text in the stat box, EG Hit:, Crit:",
						set = function(info, n) if (OSSD_ShowText == false) then OSSD_ShowText = true else OSSD_ShowText = false end OSSD_SetText(OSSD_GetValue()) end,
						get = function(info, n) return OSSD_ShowText  end,
						},
					},
				},
			},
		},
	},
}

AceConfig:RegisterOptionsTable("OSSD", ossdmod.config)



function OSSD_OnLoad(self)
	self:RegisterEvent("ADDON_LOADED");
	self:RegisterEvent("PLAYER_ENTERING_WORLD");	
	--self:RegisterEvent("UNIT_AURA");	
	SlashCmdList["OSSD"] = OSSD_Chat
	SLASH_OSSD1 = "/ossd"
	LibStub("AceConfigDialog-3.0"):AddToBlizOptions("OSSD", nil, nil, "General")	
	
end

function OSSD_Chat(msg)
	
	
	--Changing Value
	if (string.sub(msg, 0, 5) == "setw ") then
		local wid = tonumber(string.sub(msg, 6));
		if (wid == nil) then return end
		if (wid < 50) then wid = 50 end
		OSSD_FRAME:SetWidth(wid)
		OSSD_TEXT:SetWidth(wid)
		OSSD_Width = wid
		print("OSSD - Frame Width set to "..wid);
		return;
	end
	if (string.sub(msg, 0, 5) == "seth ") then
		local height = tonumber(string.sub(msg, 6));
		if (height == nil) then return end
		if (height < 17) then height = 17 end
		OSSD_FRAME:SetHeight(height)
		OSSD_TEXT:SetHeight(height)
		OSSD_Height = height
		print("OSSD - Frame Height set to "..height);
		return;
	end
	
	LibStub("AceConfigDialog-3.0"):Open("OSSD")
end

function OSSD_IsVal(val)
	if (val == OSSD_Select) then return true end
	return false
end

function OSSD_ChangeValue(val)
	DEFAULT_CHAT_FRAME:AddMessage("OSSD - Changed to |cFFFFFF00"..OSSD_SetValues[val].."|r");
	OSSD_Select = val;
	OSSD_SetText(OSSD_GetValue());
end

function OSSD_GetValue()
	local val = OSSD_Select -- Lazy!
	if (val == "sdamage") then return GetSpellBonusDamage(2) end
	if (val == "shealing") then return GetSpellBonusHealing() end
	if (val == "attackpower") then 
		local base, posBuff, negBuff = UnitAttackPower("player");
		local effective = base + posBuff + negBuff;		
		return effective;
	end
	if (val == "rattackpower") then 
		local base, posBuff, negBuff = UnitRangedAttackPower("player");
		local effective = base + posBuff + negBuff;		
		return effective;
	end
	if (val == "armor") then 
		local baseArmor , effectiveArmor, armor, posBuff, negBuff = UnitArmor("player");
		return effectiveArmor
	end
	if (val == "block") then 
		return OSSD_Format(GetBlockChance()), 1
	end
	if (val == "dodge") then 
		return OSSD_Format(GetDodgeChance()), 1
	end
	if (val == "mcrit") then 
		return OSSD_Format(GetCritChance()), 1
	end
	if (val == "rcrit") then 
		return OSSD_Format(GetRangedCritChance()), 1
	end
	if (val == "scrit") then 
		return OSSD_Format(GetSpellCritChance(2)), 1
	end
	if (val == "mhit") then 
		return GetCombatRating(6)
	end
	if (val == "rhit") then 
		return GetCombatRating(7)
	end
	if (val == "shit") then 
		return GetCombatRating(8)
	end
	if (val == "mhaste") then 
		return GetCombatRating(18)
	end
	if (val == "rhaste") then
		return GetCombatRating(19)	
	end
	if (val == "shaste") then 
		return GetCombatRating(20)
	end
	if (val == "mana") then 
		return UnitPower("player", 0)
	end
	if (val == "health") then 
		return UnitHealth("player")
	end
	if (val == "energy") then
		return UnitPower("player", 3)
	end
	if (val == "rage") then 
		return UnitPower("player", 1)
	end
	if (val == "runic") then 
		return UnitPower("player", 6)
	end
	if (val == "apen") then
		return GetArmorPenetration()
	end
	
end

function OSSD_GetNiceName(val)
	
	if (val == "sdamage") then return "SD:" end
	if (val == "shealing") then return "SH:" end
	if (val == "attackpower" or val == "rattackpower") then return "AP:" end
	
	if (val == "armor") then return "Armor:" end
	if (val == "block") then return "Block:" end
	if (val == "dodge") then return "Dodge:" end
	if (val == "mcrit" or val == "rcrit" or val == "scrit") then return "Crit:" end
	if (val == "mhit" or val == "rhit" or val == "shit") then return "Hit:" end
	if (val == "mhaste" or val == "rhaste" or val == "shaste") then return "Haste:" end
	if (val == "mana" ) then return "Mana:" end
	if (val == "health" ) then return "HP:" end
	if (val == "energy" ) then return "Energy:" end
	if (val == "rage" ) then return "Rage:" end
	if (val == "runic" ) then return "Runic:" end
	if (val == "apen") then return "Armor Pen:" end
	return val;
end

function OSSD_Format(val) return format("%.2f", val) end

function OSSD_SetText(t)
	local val = OSSD_GetValue()
	local t = OSSD_GetValue();
	if (t == nil) then return end
	if (t == "") then return end
	local pretxt = ""
	if (OSSD_ShowText == true) then pretxt = OSSD_GetNiceName(OSSD_Select).." " end
	OSSD_TEXT:SetText(pretxt..""..t);
	
	if (OSSD_Spell ~= val) then
			if (tonumber(OSSD_Spell) < tonumber(val)) then
				OSSD_TEXT:SetTextColor(0, 1, 0, 1)
			else
				OSSD_TEXT:SetTextColor(1, 0, 0, 1)
			end
		OSSD_UpdCol = 1;
	end
	OSSD_Spell = val;
end

function OSSD_OnEvent(self, event, ...)	
	if (event == "ADDON_LOADED") then
		local fontName, fontHeight, fontFlags = OSSD_TEXT:GetFont()
		OSSD_TEXT:SetFont(fontName, OSSD_TEXT_FontSize, "")
	end
	if ( event == "PLAYER_ENTERING_WORLD" ) then
		OSSD_SetText(OSSD_GetValue());
		OSSD_FRAME:SetHeight(OSSD_Height)
		OSSD_FRAME:SetWidth(OSSD_Width)
		OSSD_TEXT:SetHeight(OSSD_Height)
		OSSD_TEXT:SetWidth(OSSD_Width)
		return;
	end
	
	--if (event == "UNIT_AURA") then
	--	OSSD_SetText(OSSD_GetValue());
	--end
end

function OSSD_OnUpdate(self, elapsed)
	self.TimeSinceLastUpdate = self.TimeSinceLastUpdate + elapsed;
	if (self.TimeSinceLastUpdate > OSSD_Throttle) then

		local OSSD_Val = OSSD_GetValue();
		if (OSSD_Spell ~= OSSD_Val) then OSSD_SetText(OSSD_Val) end
		self.TimeSinceLastUpdate = 0;
	end
	if (OSSD_UpdCol ~= 1) then return end
	
	local incval = 0.0075; --Sets every frame, make this value higher if you want it to fade from a colour faster, lower for slower
	r, g, b, a = OSSD_TEXT:GetTextColor();
	if (r == 1 and g == 1 and b == 1) then OSSD_UpdCol = 0 end
	if (r < 1) then r = r + incval end
	if (g < 1) then g = g + incval end
	if (b < 1) then b = b + incval end
	OSSD_TEXT:SetTextColor(r, g, b, 1)
end
